<form [formGroup]="userForm" novalidate (ngSubmit)="onSubmit()">
  <label for="first-name">{{ "firstname" | translate }}: </label>
  <input
    id="first-name"
    type="text"
    formControlName="firstname"
    class="form-control"
  />
  <div
    *ngIf="
      userForm.controls['firstname'].invalid &&
      (userForm.controls['firstname'].dirty ||
        userForm.controls['firstname'].touched)
    "
    class="alert alert-danger p-1"
  >
    <div *ngIf="userForm.controls['firstname'].errors?.['required']">
      {{ "require" | translate }}
    </div>
  </div>

  <label for="last-name">{{ "lastname" | translate }}: </label>
  <input
    id="last-name"
    type="text"
    formControlName="lastname"
    class="form-control"
  />
  <div
    *ngIf="
      userForm.controls['lastname'].invalid &&
      (userForm.controls['lastname'].dirty ||
        userForm.controls['lastname'].touched)
    "
    class="alert alert-danger p-1"
  >
    <div *ngIf="userForm.controls['lastname'].errors?.['required']">
      {{ "require" | translate }}
    </div>
  </div>

  <label for="email">{{ "email" | translate }}: </label>
  <input id="email" type="text" formControlName="email" class="form-control" />
  <div
    *ngIf="
      userForm.controls['email'].invalid &&
      (userForm.controls['email'].dirty || userForm.controls['email'].touched)
    "
    class="alert alert-danger p-1"
  >
    <div *ngIf="userForm.controls['email'].errors?.['required']">
      {{ "require" | translate }}
    </div>
  </div>

  <label for="username">{{ "username" | translate }}: </label>
  <input
    id="username"
    type="text"
    formControlName="username"
    class="form-control"
  />
  <div
    *ngIf="
      userForm.controls['username'].invalid &&
      (userForm.controls['username'].dirty ||
        userForm.controls['username'].touched)
    "
    class="alert alert-danger p-1"
  >
    <div *ngIf="userForm.controls['username'].errors?.['required']">
      {{ "require" | translate }}
    </div>
  </div>

  <label for="password">{{ "password" | translate }}: </label>
  <input
    id="password"
    type="text"
    formControlName="password"
    class="form-control"
  />
  <div
    *ngIf="
      userForm.controls['password'].invalid &&
      (userForm.controls['password'].dirty ||
        userForm.controls['password'].touched)
    "
    class="alert alert-danger p-1"
  >
    <div *ngIf="userForm.controls['password'].errors?.['required']">
      {{ "require" | translate }}
    </div>
  </div>

  <p>{{ "form_status" | translate }}: {{ userForm.status | translate }}</p>
  <button class="btn btn-primary" type="submit" [disabled]="!userForm.valid">
    {{ buttonName | translate }}
  </button>
</form>
